import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;

public class Score {

	Vector fieldsets; // ԤϤäݻ뤿ᡣ

	//----------------------------------------------------------------------

	Score() {
		fieldsets = new Vector();
		addAnotherFieldSet();
		addAnotherFieldSet();
	}

	//----------------------------------------------------------------------

	public void init() {
		fieldsets = new Vector();
		addAnotherFieldSet();
		addAnotherFieldSet();
	}

	//----------------------------------------------------------------------
	
	public void addAnotherFieldSet() {
		fieldsets.add(new FieldSet(fieldsets.size()));
	}

	//----------------------------------------------------------------------
	
	public void removeLastFieldSet() {
		fieldsets.remove(fieldsets.size() - 1);
	}

	//----------------------------------------------------------------------
	
	public void paintStaffNotation() {
		ListIterator it = fieldsets.listIterator();
		while (it.hasNext()) {
			FieldSet field = (FieldSet)it.next();
			field.paintStaffNotation();
		}
	}

	//----------------------------------------------------------------------

	// y ϡmainPanel  y Ȥơ y ɽ Field 롣
	public Field getFieldFromY(int y) {
		if (y < 0) {
			return null;
		}
		ListIterator it = fieldsets.listIterator();
		while (it.hasNext()) {
			FieldSet fieldset = (FieldSet)it.next();
			Field f = fieldset.getFieldFromRelativeY(y);
			if (f != null) {
				return f;
			}
			y -= fieldset.getHeight();
		}
		return null;
	}

	//----------------------------------------------------------------------n

	public Note getNoteFromXY(int x, int y) {
		Field field = getFieldFromY(y);
		if (field == null) {
			return null;
		} else {
			return field.getNoteFromX(x);
		}

	}

	public Primitive getPrimitiveFromXY(int x, int y) {
		Field field = getFieldFromY(y);
		if (field == null) {
			return null;
		} else {
			return field.getPrimitiveFromX(x);
		}
	}

	//----------------------------------------------------------------------

	public int getRelativeYOfField(int y) {
		return y % Field.FIELD_HEIGHT;
	}

	//----------------------------------------------------------------------

	public LinkedList[] getNotes() {
		FieldSet firstFieldSet = (FieldSet)fieldsets.get(0);

		int size = firstFieldSet.fields.size();
		LinkedList notes[] = new LinkedList[size];
		for (int i = 0; i < size; ++i) {
			notes[i] = new LinkedList();
		}
		
		ListIterator it = fieldsets.listIterator();
		while (it.hasNext()) {
			FieldSet fieldset = (FieldSet)it.next();
			for (int i = 0; i < size; ++i) {
				Field field = (Field)fieldset.fields.get(i);
				notes[i].addAll(field.notes);
			}
		}
		return notes;
	}
}

//----------------------------------------------------------------------------------------------------

class FieldSet {

	int nth;        // this FieldSet is nth FieldSet.
	Vector fields;  // FieldSet has some Fields.

	//----------------------------------------------------------------------

	FieldSet(int vp) {
		nth = vp;
		fields = new Vector();
		fields.add(new Field(this, fields.size(), vp, Field.TREBLE));
		fields.add(new Field(this, fields.size(), vp, Field.BASS));
	}

	//----------------------------------------------------------------------
	
	public int getHeight() {
		return fields.size() * Field.FIELD_HEIGHT;
	}

	//----------------------------------------------------------------------

	public void paintStaffNotation() {
		ListIterator it = fields.listIterator();
		while (it.hasNext()) {
			Field field = (Field)it.next();
			field.paintStaffNotation();
		}
	}

	//----------------------------------------------------------------------

	public Field getFieldFromRelativeY(int relativeY) {
		if (relativeY < 0) {
			return null;
		}
		int size = fields.size();
		if (relativeY >= size * Field.FIELD_HEIGHT) {
			return null;
		} else {
			return (Field)fields.get(relativeY / Field.FIELD_HEIGHT);
		}
	}

}


//----------------------------------------------------------------------

class Field {
	
	static final int MARGIN = 40;
	static final int FIELD_HEIGHT = 140; // including margin.

	// 0 - 4, 5 - 14, 15 - 25, ...
	static final int pitchOnLine[] = {
		-1, -1, -1, 81, 77, 74, 71, 67, 64, 60, 57, 53, 50, -1, -1
	};

	// 0 - 9, 10 - 19, 20 - 30, ...
	static final int pitchBetweenLine[] = {
		-1, -1, 83, 79, 76, 72, 69, 65, 62, 59, 55, 52, 48, -1, -1
	};

	// 0 - 4, 5 - 9, 10 - 14, 15 - 19, ...
	static final int pitch[] = {
		-1, -1, -1, -1, 83, 81, 79, 77, 76, 74, 72, 71, 69, 67, 65,
		64, 62, 60, 59, 57, 55, 53, 52, 50, 48, -1, -1, -1, -1, -1
	};

	// 0 - 4, 5 - 14, 15 - 25, ...
	static final int pitchOnLineBass[] = {
		-1, -1, -1, 60, 57, 53, 50, 47, 43, 40, 36, 33, 29, -1, -1
	};

	// 0 - 9, 10 - 19, 20 - 30, ...
	static final int pitchBetweenLineBass[] = {
		-1, -1, 62, 59, 55, 52, 48, 45, 41, 38, 35, 31, 28, -1, -1
	};

	// 0 - 4, 5 - 9, 10 - 14, 15 - 19, ...
	static final int pitchBass[] = {
		-1, -1, -1, -1, 62, 60, 59, 57, 55, 53, 52, 50, 48, 47, 45,
		43, 41, 40, 38, 36, 35, 33, 31, 29, 28, -1, -1, -1, -1, -1,
	};

	public static final int TREBLE = 0;
	public static final int BASS   = 1;

	private static final Image treble_image = Main.toolkit.getImage("image/treble.png");
	private static final Image bass_image   = Main.toolkit.getImage("image/bass.png");

	FieldSet parent;
	int nthField;
	int vertical_position; // 
	LinkedList notes;      // contain notes;
	int cref;

	//----------------------------------------------------------------------

	Field(FieldSet p, int vp, int nth, int c) {
		parent = p;
		vertical_position = vp;
		nthField = nth;
		notes = new LinkedList();
		cref = c;
	}

	//----------------------------------------------------------------------

	public int getY() {
		return FIELD_HEIGHT * (vertical_position) + nthField * FIELD_HEIGHT * 2;
	}

	//----------------------------------------------------------------------

	public void addNoteWithoutUndo(Note n) {
		if (n instanceof BasicNote) {
			BasicNote bn = (BasicNote)n;
			if (bn.pitch < 0) {
				return;
			}
		}

		ListIterator it = notes.listIterator();
		int i = 0;
		while (it.hasNext()) {
			Note note = (Note)it.next();
			if (n.horizonPosition < note.horizonPosition) {
				break;
			}
			++i;
		}
		notes.add(i, n);
	}

	public void addNoteWithUndo(Note n, Undo undo) {
		addNoteWithoutUndo(n);
		undo.makeUndo(Undo.REMOVE_NOTE, this, n);
	}

	//----------------------------------------------------------------------

	public void removeNoteWithoutUndo(Note n) {
		notes.remove(n);
	}

	public void removeNoteWithUndo(Note n, Undo undo) {
		removeNoteWithoutUndo(n);
		undo.makeUndo(Undo.ADD_NOTE, this, n);
	}
	
	public void removeNotesWithoutUndo(LinkedList ns) {
		ListIterator it = ns.listIterator();
		while (it.hasNext()) {
			Note note = (Note)it.next();
			notes.remove(note);
		}
	}

	public void removeNotesWithUndo(LinkedList ns, Undo undo) {
		ListIterator it = ns.listIterator();
		while (it.hasNext()) {
			Note note = (Note)it.next();
			notes.remove(note);
		}
		undo.makeUndo(Undo.ADD_NOTE, this, ns);
	}

	//----------------------------------------------------------------------

	public BeamedNote beamNoteWithoutUndo(LinkedList notesToBeBeamed) {
		ListIterator it = notesToBeBeamed.listIterator();

		// ޤƤʬʾ彽ϻʬʲǤ뤳Ȥߤ롣
		while (it.hasNext()) {
			Note n = (Note)it.next();
			if (!(n instanceof BasicNote)) {
				return null;
			}
			BasicNote note = (BasicNote)n;
			if (note.type <= BasicNote.NOTE2 || BasicNote.NOTE32 <= note.type) {
				return null;
			}
		}

		// ˡ beam 롣
		it = notesToBeBeamed.listIterator();
		while (it.hasNext()) {
			BasicNote note = (BasicNote)it.next();
			removeNoteWithoutUndo(note);
			note.halveNoteWithoutUndo();
		}

		BeamedNote beamed = new BeamedNote(this, notesToBeBeamed);
		addNoteWithoutUndo(beamed);
		return beamed;
	}

	public void beamNoteWithUndo(LinkedList notesToBeBeamed, Undo undo) {
		BeamedNote bn = beamNoteWithoutUndo(notesToBeBeamed);
		if (bn != null) {
			undo.makeUndo(Undo.UNBEAM_NOTE, this, bn);
		}
	}

	//----------------------------------------------------------------------

	public LinkedList unbeamNoteWithoutUndo(BeamedNote note) {
		removeNoteWithoutUndo(note);

		LinkedList notesToAdd = note.notes;
		ListIterator it       = notesToAdd.listIterator();
		while (it.hasNext()) {
			BasicNote bn = (BasicNote)it.next();
			bn.doubleNoteWithoutUndo();
			addNoteWithoutUndo(bn);
		}

		return notesToAdd;
	}

	public void unbeamNoteWithUndo(BeamedNote note, Undo undo) {
		LinkedList ns = unbeamNoteWithoutUndo(note);
		undo.makeUndo(Undo.BEAM_NOTE, this, ns);
	}

	//----------------------------------------------------------------------

	public void paintStaffNotation() {
		Graphics g = Main.getGraphics();

		// ǽˡCREF 
		if (cref == TREBLE) {
			g.drawImage(treble_image, 30, getY() + MARGIN - 13, 25, 70, Main.root.mainPanel);
		} else if (cref == BASS) {
			g.drawImage(bass_image, 30, getY() + MARGIN, 23, 32, Main.root.mainPanel);
		}

		// ˡ
		ListIterator it = notes.listIterator();
		while (it.hasNext()) {
			Note note = (Note)it.next();
			note.paintNote();
		}

		// Ǹˡ
		for (int i = 0; i < 5; ++i) {
			Dimension d = Main.root.mainPanel.getSize();
			int y = getY() + MARGIN + Main.LINEHEIGHT * i;
			g.drawLine(30, y, d.width - 30, y);
		}

	}

	//----------------------------------------------------------------------

	Note getNoteFromX(int x) {
		ListIterator it = notes.listIterator();
		while (it.hasNext()) {
			Note note = (Note)it.next();
			if (note.horizonPosition <= x && x <= note.horizonPosition + note.width) {
				return note;
			}
		}

		return null;
	}

	Primitive getPrimitiveFromX(int x) {
		Note note = getNoteFromX(x);

		if (note == null) {
			return null;
		}

		if (note instanceof Primitive) {
			return (Primitive)note;
		}

		BeamedNote beamed = (BeamedNote)note;
		ListIterator it = beamed.notes.listIterator();
		while (it.hasNext()) {
			BasicNote bn = (BasicNote)it.next();
			if (bn.horizonPosition <= x && x <= bn.horizonPosition + bn.width) {
				return bn;
			}
		}

		return null;
	}

	//----------------------------------------------------------------------

	// Line Ǥ뤫ɤǡʬ롣
	int getPitchFromRelativeY(int relativeY, boolean onLine) {
		if (cref == TREBLE) {
			if (onLine) {
				int x = (relativeY + 5) / 10;
				return pitchOnLine[x];
			} else {
				int x = (relativeY + 5) / 10;
				return pitchBetweenLine[x];
			}
		} else if (cref == BASS) {
			if (onLine) {
				int x = (relativeY + 5) / 10;
				return pitchOnLineBass[x];
			} else {
				int x = (relativeY + 5) / 10;
				return pitchBetweenLineBass[x];
			}
		}
		Main.failwith("getPitchFromRelativeY");
		return -1;
	}

	int getPitchFromRelativeY(int relativeY) {
		if (cref == TREBLE) {
			return pitch[(relativeY - 3) / 5];
		} else if (cref == BASS) {
			return pitchBass[(relativeY - 3) / 5];
		}

		Main.failwith("getPitchFromRelativeY");
		return -1;
	}

}
